$crystal = 8000000
$regfile = "m8515.dat"
$hwstack = 32
$swstack = 8
$framesize = 32

Config Porta = Output         'PORTA izhod

Porta.2 = 0 : Porta.3 = 0     'motor 3 izkljuen
Wait 1

'* DC motor 3, slika 5
'* sprememba smeri, stop

Gosub M3_levo               'pozeni motor 3 v levo
Wait 5                        'naj se malo vrti
Gosub M3_stop                 'stop motor 3
Wait 1                        'poakaj da se motor ustavi
Gosub M3_desno                'pozeni motor 3 v desno
Wait 5                        'naj se malo vrti
Gosub M3_stop                 'stop motor 3
Wait 2

'* DC motor 3, slika 5
'* sprememba smeri in kontrola hitrosti

Dim Brzina_3a As Byte , Brzina_3b As Byte
On Timer0 Tim0_sub
Enable Interrupts
'Config Timer0 = Timer , Prescale = 64
ldi r24,3
!out tccr0,r24

Brzina_3a = &B00000000
Brzina_3b = &B11111111        'polna hitrost L
Enable Timer0
Wait 2
Brzina_3b = &B11110000        'zmanjsaj hitrost L
Wait 2
Brzina_3b = &B11000000        'zmanjsaj hitrost L
Wait 2
Brzina_3b = &B00000000        'stoj
Wait 2
Brzina_3a = &B11000000        'pozeni D
Wait 2
Brzina_3a = &B11110000        'povecaj hitrost D
Wait 2
Brzina_3a = &B11111111        'polna hitrost D
Wait 2
Brzina_3a = &B00000000        'stoj
Wait 2

End

M3_levo:
   Porta.2 = 1
   Porta.3 = 0
Return

M3_desno:
   Porta.2 = 0
   Porta.3 = 1
Return

M3_stop:
   Porta.2 = 0
   Porta.3 = 0
Return

Tim0_sub:
   Porta.2 = Brzina_3a.0
   Rotate Brzina_3a , Right
   Porta.3 = Brzina_3b.0
   Rotate Brzina_3b , Right
Return