$crystal = 8000000
$regfile = "m8515.dat"
$hwstack = 32
$swstack = 8
$framesize = 32

Config Porta = Output                                       'PORTA izhod

Porta.0 = 1                                                 'motor 1 izkljuen
Porta.1 = 0                                                 'motor 2 izkljuen
Wait 1

'* DC motor 1 in 2, slika 5
'* start/stop

Porta.0 = 0                                                 'start motor 1
Porta.1 = 1                                                 'start motor 2
Wait 5                                                      'naj malo delata
Porta.0 = 1                                                 'stop motor 1
Porta.1 = 0                                                 'stop motor 2
Wait 2

'* DC motor 1, slika 5
'* kontrola hitrosti

Dim Dc_i As Byte
For Dc_i = 1 To 250                                         'hitrost se regulira
   Gosub M1_start                                           'izmeninim vkljuevanjem
   Waitms 10
   Gosub M1_stop                                            'in izkljuevanjem
   Waitms 10                                                'motorja
Next                                                        'motor vkljuen 250*20ms=5s
Wait 2

'* DC motor 1, slika 5
'* kontrola hitrosti (prekintve)

Dim Brzina_1 As Byte
On Timer0 Tim0_sub
Enable Interrupts
'Config Timer0 = Timer , Prescale = 64
ldi r24,3
!out tccr0,r24

Brzina_1 = &B11111100                                       'doloci hitrost 
Enable Timer0                                               'pozeni motor
Wait 2
Brzina_1 = &B11110000                                       'spremeni hitrost
Wait 2
Brzina_1 = &B11000000                                       'spremeni hitrost 
Wait 2
Brzina_1 = &B00000000                                       'spremeni hitrost 
Wait 2
Brzina_1 = &B11111111                                       'ustavi motor
Wait 1
Disable Timer0

End

M1_start:
   Porta.0 = 0                                              'start motor 1
Return

M1_stop:
   Porta.0 = 1                                              'stop motor 1
Return

Tim0_sub:
   Porta.0 = Brzina_1.0
   Rotate Brzina_1 , Right
Return