$crystal = 8000000
$regfile = "m8515.dat"
$hwstack = 32
$swstack = 8
$framesize = 32

'* servo motor, slika 7
'* (!koristi Timer1!)

Dim Servo As Word

Servo1_pin Alias Portc.0      'servo1 upravljalni pin
Servo2_pin Alias Portc.1      'servo2 upravljalni pin
Gosub Config_servo

Wait 2

Servo = 1500 : Gosub Servo1   'srednji poloaj
Wait 1                        'poakaj malo

For Servo = 1500 To 2350 Step 5 'pojdi postopno v jedan koncni poloaj
   Gosub Servo1
   Waitms 50
Next
Wait 1

Servo = 650 : Gosub Servo1    'skoi v drugi koncni poloaj
Wait 1
Servo = 1500 : Gosub Servo1   'vrni se v sredino

Do
Loop

End

Dim Servo_pom As Long

Servo1:
   Gosub Servo12
   Disable Interrupts
   Compare1a = Servo_pom
   Enable Interrupts
Return

Servo2:
   Gosub Servo12
   Disable Interrupts
   Compare1b = Servo_pom
   Enable Interrupts
Return

Servo12:
   Servo_pom = -1
   Decr Servo
   If Servo < 20000 Then
      Servo_pom = _xtal / 1000
      Servo_pom = Servo_pom * Servo
      Servo_pom = Servo_pom / 8000
   End If
   Incr Servo
Return

Config_servo:
   Config Servo1_pin = Output
   Config Servo2_pin = Output

   On Compare1a C1a_sub Nosave
   On Compare1b C1b_sub Nosave
   On Capture1 T1_sub Nosave

   Compare1a = -1
   Compare1b = -1
   Capture1 = _xtal / 400

   Enable Compare1a
   Enable Compare1b
   Enable Capture1
   Enable Interrupts

   Config Timer1 = Timer , Prescale = 8 , Clear Timer = 1
   Set Tccr1b.wgm13
Return

C1a_sub:
   Reset Servo1_pin
Return

C1b_sub:
   Reset Servo2_pin
Return

T1_sub:
   Set Servo1_pin
   Set Servo2_pin
Return